#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>
#include <tuple>
using namespace std;

ifstream fin("dijkstra.in");
ofstream fout("dijkstra.out");

const int Inf = 0x3f3f3f3f;

using PI  = pair<int, int>;
using VI  = vector<int>;
using VP  = vector<PI>;
using VVP = vector<VP>;

VI d;
VVP G; // graful
int n;

void ReadGraph();
void Dijkstra(int x, VI& d);
void WriteDistances();


int main()
{
	ReadGraph();
	Dijkstra(1, d);
	WriteDistances();
}

void Dijkstra(int x, VI& d)
{
	d = VI(n + 1, Inf);
	priority_queue<PI, vector<PI>, greater<PI>> Q; // min HEAP
	d[x] = 0;
	Q.emplace(0, x);
	
	while (!Q.empty())
	{
		auto [dist, x] = Q.top();
		Q.pop();
		
		if (dist > d[x])
			continue;
		
		for (auto& p : G[x])
		{
			auto [y, w] = p;
			if (d[y] > d[x] + w)
			{
				d[y] = d[x] + w;
				Q.emplace(d[y], y);
			}
		}	
	}	
}

void ReadGraph()
{
	int x, y, w, m;
	fin >> n >> m;
	G = VVP(n + 1);
	
	while (m--)
	{
		fin >> x >> y >> w;
		G[x].emplace_back(y, w);
		G[y].emplace_back(x, w);
	}
}

void WriteDistances()
{
	for (int i = 1; i <= n; ++i)
		fout << d[i] << ' ';
}







